// This program is copyright VUW.
// You are granted permission to use it to construct your answer to a COMP102 Lab Assessment.
// You may not distribute it in any other way without permission.

/* Code for COMP102 - 2020T3, Lab Assessment 3
 * Name:
 * Username:
 * ID:
 */

import ecs100.*;

import java.awt.Color;

/**
 * A circle that can be drawn on the UI, and can grow and shrink.
 * 
 * DO NO MODIFY THIS CLASS.
 */

public class Circle {
    // Fields
    private Color color;
    private double size;
    private double x, y;

    /**
     * Constructor for a circle.
     *
     * @param x,y   The position of the circle on the screen
     * @param size  The initial diameter of the circle
     * @param color The colour of the circle
     */
    public Circle(double x, double y, double size, Color color) {
        this.x = x;
        this.y = y;
        this.size = size;
        this.color = color;
    }

    /**
     * Makes the circle grow 5 pixels
     */
    public void grow() {
        this.erase();
        this.size = this.size + 5;
        this.draw();
    }

    /**
     * Makes the circle shrink by the provided amount.
     *
     * @param amount The number of pixels to shrink the circle.
     */
    public void shrink(double amount) {
        this.erase();
        this.size = this.size - amount;
        this.draw();
    }

    /**
     * Draws the circle on the UI
     */
    public void draw() {
        UI.setColor(this.color);
        UI.fillOval(x - size / 2, y - size / 2, size, size);
        UI.sleep(100);
    }

    /**
     * Erases the circle from the UI
     */
    public void erase() {
        UI.eraseOval(x - size / 2, y - size / 2, size, size);
    }
}
